﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Runtime.Serialization;
using System.Runtime.Serialization.Formatters.Binary;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace WindowsFormsApp3
{
    public partial class Form1 : Form
    {
        Student student1;
        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            student1 = new Student();
            student1.Name = "Marios";
            Student student2 = new Student();
            student2.Name = "Giannis";
            student1.Age = 19;
            student2.Age = 20;
        }

        private void button2_Click(object sender, EventArgs e)
        {
            IFormatter formatter = new BinaryFormatter();
            Stream stream = new FileStream("student1.ser",
                FileMode.OpenOrCreate, FileAccess.Write);
            formatter.Serialize(stream, student1);
            stream.Close();
            MessageBox.Show("Done!");
        }

        private void button3_Click(object sender, EventArgs e)
        {
            IFormatter formatter = new BinaryFormatter();
            Stream stream = new FileStream("student1.ser", FileMode.Open, FileAccess.Read);
            Student newStudent1 = (Student)formatter.Deserialize(stream);
            MessageBox.Show(newStudent1.Name);
            Form2 form2 = new Form2();
            form2.Show();
        }

        private void button4_Click(object sender, EventArgs e)
        {
            comboBox1.Items.Clear();
            MessageBox.Show(Application.OpenForms.Count.ToString());
            foreach(Form form in Application.OpenForms)
            {
                comboBox1.Items.Add(form.Name);
            }
        }

        private void button5_Click(object sender, EventArgs e)
        {
            if(Application.OpenForms.Count > 1)
            {
                if (Application.OpenForms[1] is Form2)
                    MessageBox.Show(((Form2)Application.OpenForms[1]).message);
                if(Application.OpenForms[1].GetType() == typeof(Form2))
                    MessageBox.Show(((Form2)Application.OpenForms[1]).label1.Text);//Bad practice
            }
        }
    }
}
